import BN from "bn.js";
import { IXrpGetTransactionRes, XrpTransactionTypeUnion } from "../../types/xrpTypes";
import { AddressAmount, BalanceDecreasingProps, BalanceDecreasingSummaryResponse, PaymentSummaryProps, PaymentSummaryResponse, TransactionBase } from "../TransactionBase";
import { MccClient } from "../../module";
import { TransactionSuccessStatus } from "../../types/genericMccTypes";
export declare class XrpTransaction extends TransactionBase {
    protected get data(): IXrpGetTransactionRes;
    get txid(): string;
    get stdTxid(): string;
    get hash(): string;
    get reference(): string[];
    get stdPaymentReference(): string;
    get unixTimestamp(): number;
    get sourceAddresses(): string[];
    get assetSourceAddresses(): (string | undefined)[];
    get receivingAddresses(): string[];
    get assetReceivingAddresses(): (string | undefined)[];
    get fee(): BN;
    get feeSignerTotalAmount(): AddressAmount;
    get spentAmounts(): AddressAmount[];
    get intendedSpentAmounts(): AddressAmount[];
    get assetSpentAmounts(): AddressAmount[];
    get receivedAmounts(): AddressAmount[];
    get intendedReceivedAmounts(): AddressAmount[];
    get assetReceivedAmounts(): AddressAmount[];
    get type(): XrpTransactionTypeUnion;
    get isNativePayment(): boolean;
    get currencyName(): string;
    get elementaryUnits(): BN;
    get successStatus(): TransactionSuccessStatus;
    paymentSummary(props: PaymentSummaryProps): Promise<PaymentSummaryResponse>;
    balanceDecreasingSummary({ sourceAddressIndicator }: BalanceDecreasingProps): Promise<BalanceDecreasingSummaryResponse>;
    makeFull(client?: MccClient): Promise<void>;
    private get metaObject();
    get isAccountCreate(): boolean;
}
//# sourceMappingURL=XrpTransaction.d.ts.map