declare type encoding = "bech32" | "bech32m";
declare type hrp = "bc" | "tb";
export declare function hrpExpand(hrp: hrp): number[];
export declare function bech32_encode(hrp: hrp, data: number[], enc: encoding): string | null;
export declare function bech32_decode(bechString: string, enc: encoding): {
    hrp: hrp;
    data: number[];
} | null;
export declare function bech32_decodeWithCheckSum(bechString: string, enc: encoding): {
    hrp: hrp;
    data: number[];
} | null;
export declare function convertBits(data: number[], fromBits: number, toBits: number, pad: boolean): number[] | null;
export declare function bech32Decode(addr: string): {
    version: number;
    program: number[];
} | null;
export declare function bech32Encode(hrp: hrp, version: number, program: number[]): string | null;
export declare function bech32AddressToHex1(address: string): string;
export declare function bech32AddressToHex2(address: string): string | null;
/**
 * Returns pkscript corresponding to a bech32 address.
 * @param address in bech32 or bech32m
 * @returns
 */
export declare function bech32AddressToPkscript(address: string): string;
export {};
//# sourceMappingURL=bech32.d.ts.map